LeetCode 292. Nim Game

LeetCode 292. Nim Game

一个数学问题。

题目

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

思考

先考虑石子少的情况。

石子数量:1/2/3
移走石子数量(按顺序):1/2/3
胜利者:我

石子数量:4个
移走石子数量(按顺序):1,3或者2,2或者3,1
胜利者:朋友

石子数量:5个
移走石子数量(按顺序):我先移走1个石子,剩下4个石子按照上一个例子来看,因为轮到他拿,所以我赢了
胜利者:我

从上述例子可以看出,当石子数量(多于4)是4的倍数时,胜利者是朋友,否则我赢。

我的答案

c++

class Solution {
public:
    bool canWinNim(int n) {
        return (n % 4 == 0 ? false : true);
    }
};

一个不公平的游戏。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值